%define contentdir /var/www
%define mm_ver 1.1.3
%define apache_ver 1.3.22
%define mod_ssl_ver %{version}-1.3.23

Summary: Cryptography support for the Apache Web server.
Name: stronghold-mod_ssl
Version: 2.8.7
Release: 5
Group: System Environment/Daemons
Source0: ftp://ftp.modssl.org/source/mod_ssl-%{mod_ssl_ver}.tar.gz
Source1: SSL-Certificate-Creation
Source3: ssl_vendor_sh2_misc.c
Patch0: mod_ssl-2.6.4-tty.patch
Patch1: mod_ssl-2.8.4-sdbm.patch
Patch2: mod_ssl-2.8.4-openssl.patch
Patch3: mod_ssl-2.8.4-shmcb.patch
Patch4: mod_ssl-2.8.3-ppenv.patch
Patch5: mod_ssl-2.8.5-authz.patch
Patch6: mod_ssl-2.8.7-gofaster.patch
Patch7: mod_ssl-2.8.7-obo.patch
Patch8: mod_ssl-2.8.7-xss.patch
Patch9: mod_ssl-2.8.7-ffcc.patch
License: BSDish
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildPrereq: openssl-devel
BuildPrereq: stronghold-apache-devel = %{apache_ver}, eapi = %{version}, mm-devel
Requires: webserver, make
Prereq: openssl, dev
Obsoletes: mod_ssl
Requires: %(cat %{_includedir}/apache/.eapi-tag)

%description
The mod_ssl module provides strong cryptography for the Apache Web
server via the Secure Sockets Layer (SSL) and Transport Layer Security
(TLS) protocols.

%prep
%setup -q -n mod_ssl-%{mod_ssl_ver}
%patch0 -p2 -b .tty
%patch1 -p1 -b .sdbm
%patch2 -p1 -b .openssl
%patch3 -p0 -b .shmcb
%patch4 -p0 -b .ppenv
%patch5 -p0 -b .authz
%patch6 -p1 -b .gofaster
%patch7 -p0 -b .obo
%patch8 -p0 -b .xss
%patch9 -p0 -b .ffcc

cp %{SOURCE3} pkg.sslmod

%build
CFLAGS="$RPM_OPT_FLAGS -fPIC" ; export CFLAGS

SSL_COMPAT=yes
SSL_EXPERIMENTAL=yes
SSL_VENDOR=yes
export SSL_COMPAT SSL_EXPERIMENTAL SSL_VENDOR
# The --force below keeps configure from failing when the httpd binary
# is not present, and changes nothing else.
%configure --with-apxs=%{_sbindir}/apxs --with-mm=SYSTEM --force
make

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT`%{_sbindir}/apxs -q LIBEXECDIR`
install -m755 pkg.sslmod/libssl.so $RPM_BUILD_ROOT`%{_sbindir}/apxs -q LIBEXECDIR`

# install config information
for suffix in crl crt csr key prm ; do
	mkdir -p $RPM_BUILD_ROOT/`%{_sbindir}/apxs -q SYSCONFDIR`/ssl.${suffix}
	install -m644 pkg.sslcfg/*.${suffix} $RPM_BUILD_ROOT/`%{_sbindir}/apxs -q SYSCONFDIR`/ssl.${suffix}
	rm -f $RPM_BUILD_ROOT/`%{_sbindir}/apxs -q SYSCONFDIR`/ssl.${suffix}/server.*
done
chmod 600 $RPM_BUILD_ROOT/`%{_sbindir}/apxs -q SYSCONFDIR`/ssl.*/*.key

# install docs
mkdir -p $RPM_BUILD_ROOT%{contentdir}/manual/apache/mod/mod_ssl/
install -m644 pkg.ssldoc/*.{html,gif,jpg} \
	$RPM_BUILD_ROOT%{contentdir}/manual/apache/mod/mod_ssl/

# point to the right makefile.
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf
ln -s ../../../usr/share/ssl/certs/Makefile $RPM_BUILD_ROOT/etc/httpd/conf

find $RPM_BUILD_ROOT -type f | \
	xargs grep -l "/usr/local/bin/perl5" | \
	xargs perl -pi -e "s|/usr/local/bin/perl5|%{__perl}|g;"
find $RPM_BUILD_ROOT -type f | \
	xargs grep -l "/usr/local/bin/perl" | \
	xargs perl -pi -e "s|/usr/local/bin/perl|%{__perl}|g;"

# create a prototype session cache
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/cache
touch $RPM_BUILD_ROOT%{_localstatedir}/cache/ssl_gcache_data.{dir,pag,sem}

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig
umask 077

if [ ! -f %{_sysconfdir}/httpd/conf/ssl.key/server.key ] ; then
%{_bindir}/openssl genrsa -rand /proc/apm:/proc/cpuinfo:/proc/dma:/proc/filesystems:/proc/interrupts:/proc/ioports:/proc/pci:/proc/rtc:/proc/uptime 1024 > %{_sysconfdir}/httpd/conf/ssl.key/server.key 2> /dev/null
fi

FQDN=`hostname`
if [ "x${FQDN}" = "x" ]; then
   FQDN=localhost.localdomain
fi

if [ ! -f %{_sysconfdir}/httpd/conf/ssl.crt/server.crt ] ; then
cat << EOF | %{_bindir}/openssl req -new -key %{_sysconfdir}/httpd/conf/ssl.key/server.key -x509 -days 365 -out %{_sysconfdir}/httpd/conf/ssl.crt/server.crt 2>/dev/null
--
SomeState
SomeCity
SomeOrganization
SomeOrganizationalUnit
${FQDN}
root@${FQDN}
EOF
fi

%files
%defattr(-,root,root)
%doc $RPM_SOURCE_DIR/SSL-Certificate-Creation README* LICENSE NEWS CHANGES CREDITS
%{contentdir}/manual/apache/mod/mod_ssl/
%{_libdir}/apache/libssl.so
%config %{_sysconfdir}/httpd/conf/Makefile
%attr(0700,root,root) %dir %{_sysconfdir}/httpd/conf/ssl.*
%attr(0600,apache,root) %ghost %{_localstatedir}/cache/ssl_gcache_data.dir
%attr(0600,apache,root) %ghost %{_localstatedir}/cache/ssl_gcache_data.pag
%attr(0600,apache,root) %ghost %{_localstatedir}/cache/ssl_gcache_data.sem
%dir %{_sysconfdir}/httpd
%config %{_sysconfdir}/httpd/conf/ssl.*/*
  
%changelog
* Wed Oct  9 2002 Joe Orton <jorton@redhat.com> stronghold-2.8.7-5
- include security fixes and CAN-2002-1157.
- add 'SSLProxyForceFirstClientCert' directive.

* Tue Jul  9 2002 Joe Orton <jorton@redhat.com> stronghold-2.8.7-4
- add fix for off-by-one error (CVE CAN-2002-0653)

* Wed Apr 10 2002 Joe Orton <jorton@redhat.com> stronghold-2.8.7-3
- add performance fix for entropy seeding from scoreboard (from Nalin)

* Tue Apr 09 2002 Gary Benson <gbenson@redhat.com> stronghold-2.8.7-2
- sanitize license fields

* Fri Apr 05 2002 Gary Benson <gbenson@redhat.com> stronghold-2.8.7-1
- stronghold-openssl is now openssl.

* Mon Mar 25 2002 Gary Benson <gbenson@redhat.com>
- upgrade to 2.8.7 (built against 1.3.22)
- remove the log rotation stuff (it wasn't used anyway, and
  stronghold-apache rotates all logs in /var/log/httpd).

* Tue Feb 26 2002 Joe Orton <jorton@redhat.com> stronghold-2.8.5-5
- add patch for mod_authz_ldap

* Thu Feb 14 2002 Gary Benson <gbenson@redhat.com> stronghold-2.8.5-4
- move the manual from /var/www/manual to /var/www/manual/apache.

* Wed Jan 30 2002 Joe Orton <jorton@redhat.com> stronghold-2.8.5-3
- create dummy cert for `hostname` not localhost

* Tue Jan 29 2002 Joe Orton <jorton@redhat.com> stronghold-2.8.5-2
- add build dependency on stronghold-apache-devel

* Mon Jan 21 2002 Gary Benson <gbenson@redhat.com>
- Move manual from /var/www/html/manual to /var/www/manual
  (safely out of Tux's way)

* Thu Jan 17 2002 Joe Orton <jorton@redhat.com> stronghold-2.8.5-1
- add enhanced mod_status, certificate expiry warning e-mail, 
  ProxyPassEnv directive, shmcb bug fixes

* Mon Oct 11 2001 Nalin Dahyabhai <nalin@redhat.com> 2.8.5-1
- update to 2.8.5

* Thu Oct 11 2001 Nalin Dahyabhai <nalin@redhat.com> 2.8.4-10
- update to build against and require 1.3.22

* Tue Jul 24 2001 Nalin Dahyabhai <nalin@redhat.com> 2.8.4-9
- mark files under %%{_sysconfdir} as configuration files
- add dependency on make to ensure that makefiles are usable

* Mon Jul 23 2001 Nalin Dahyabhai <nalin@redhat.com>
- remove a patch

* Thu Jul 19 2001 Nalin Dahyabhai <nalin@redhat.com>
- don't package a default server.anything
- use system mm library
- use --force when configuring so that we don't error out -- the apxs
  script still works

* Wed Jul 18 2001 Nalin Dahyabhai <nalin@redhat.com>
- add a mod_ssl.logrotate configuration file to the package

* Fri Jul 12 2001 Nalin Dahyabhai <nalin@redhat.com>
- break out of the apache package
